/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.decoder;

import static ru.ispras.microtesk.model.minimips.TypeDefs.*;

import ru.ispras.microtesk.decoder.DecoderItem;
import ru.ispras.microtesk.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.api.data.Type;
import ru.ispras.microtesk.model.minimips.op.jr;
import ru.ispras.microtesk.model.minimips.mode.REG;

/**
 * The {@code DecoderJr} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJr extends DecoderItem {
  private static DecoderJr instance = null;

  public static DecoderJr get() {
    if (null == instance) {
      instance = new DecoderJr();
    }
    return instance;
  }

  private DecoderJr() {
    super(
        32,
        true,
        "00000000000000000000000000001000",
        "11111100000111111111111111111111"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    REG addr = null;

    if (!matchNextOpc(image, BitVector.valueOf("000000", 2, 6))) {
      return null;
    }

    addr = (REG) readNextPrimitive(image, DecoderREG.get());
    if (null == addr) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("000000000000000001000", 2, 21))) {
      return null;
    }

    return newResult(new jr(addr));
  }
}
